
#ifndef GAME_H
#define GAME_H

// the game modes
#define GAME_MODE_SPLASH_1                     0
#define GAME_MODE_SPLASH_2                     1
#define GAME_MODE_SPLASH_3                     2
#define GAME_MODE_SPLASH_4                     3
#define GAME_MODE_SPLASH_5                     4
#define GAME_MODE_SPLASH_EXIT                  5
#define GAME_MODE_MENU_MAIN                    6
#define GAME_MODE_MENU_CREDITS_IN              7
#define GAME_MODE_MENU_CREDITS                 8
#define GAME_MODE_MENU_CREDITS_OUT             9
#define GAME_MODE_MENU_MULTIPLAYER_IN         10
#define GAME_MODE_MENU_MULTIPLAYER            11
#define GAME_MODE_MENU_MULTIPLAYER_OUT        12
#define GAME_MODE_MENU_CONNECTION_IN          13
#define GAME_MODE_MENU_CONNECTION             14
#define GAME_MODE_MENU_CONNECTION_OUT         15
#define GAME_MODE_MENU_LEVEL_SELECTION_MP_IN  16
#define GAME_MODE_MENU_LEVEL_SELECTION_MP     17
#define GAME_MODE_MENU_LEVEL_SELECTION_MP_OUT 18
#define GAME_MODE_MENU_SETTINGS_IN            19
#define GAME_MODE_MENU_SETTINGS               20
#define GAME_MODE_MENU_SETTINGS_OUT           21
#define GAME_MODE_MENU_GAME_MP_IN             22
#define GAME_MODE_MENU_GAME_MP                23
#define GAME_MODE_MENU_GAME_MP_OUT            24

// menu centers
#define GAME_MENU_CENTER_SPLASH_1_X                 400.0f
#define GAME_MENU_CENTER_SPLASH_1_Y                   0.0f
#define GAME_MENU_CENTER_SPLASH_2_X                 580.0f
#define GAME_MENU_CENTER_SPLASH_2_Y                   0.0f
#define GAME_MENU_CENTER_SPLASH_3_X                 760.0f
#define GAME_MENU_CENTER_SPLASH_3_Y                   0.0f
#define GAME_MENU_CENTER_MENU_MAIN_X               1100.0f
#define GAME_MENU_CENTER_MENU_MAIN_Y                  0.0f
#define GAME_MENU_CENTER_MENU_SETTINGS_X           1100.0f
#define GAME_MENU_CENTER_MENU_SETTINGS_Y           -200.0f
#define GAME_MENU_CENTER_MENU_CREDITS_X            1100.0f
#define GAME_MENU_CENTER_MENU_CREDITS_Y             200.0f
#define GAME_MENU_CENTER_MENU_MULTIPLAYER_X        1280.0f
#define GAME_MENU_CENTER_MENU_MULTIPLAYER_Y           0.0f
#define GAME_MENU_CENTER_MENU_CONNECTION_X         1460.0f
#define GAME_MENU_CENTER_MENU_CONNECTION_Y            0.0f
#define GAME_MENU_CENTER_MENU_LEVEL_SELECTION_MP_X 1640.0f
#define GAME_MENU_CENTER_MENU_LEVEL_SELECTION_MP_Y    0.0f
#define GAME_MENU_CENTER_MENU_GAME_MP_X            1820.0f
#define GAME_MENU_CENTER_MENU_GAME_MP_Y               0.0f

// menu selections (MAIN)
#define GAME_MENU_SELECTION_MAIN_QUICK_TEST  0
#define GAME_MENU_SELECTION_MAIN_MULTIPLAYER 1
#define GAME_MENU_SELECTION_MAIN_CREDITS     2
#define GAME_MENU_SELECTION_MAIN_SETTINGS    3

// menu selections (SETTINGS)
#define GAME_MENU_SELECTION_SETTINGS_GFX   0
#define GAME_MENU_SELECTION_SETTINGS_MUSIC 1
#define GAME_MENU_SELECTION_SETTINGS_SFX   2
#define GAME_MENU_SELECTION_SETTINGS_BACK  3

// menu selections (MULTIPLAYER)
#define GAME_MENU_SELECTION_MULTIPLAYER_NAME    0
#define GAME_MENU_SELECTION_MULTIPLAYER_SERVER  1
#define GAME_MENU_SELECTION_MULTIPLAYER_CONNECT 2
#define GAME_MENU_SELECTION_MULTIPLAYER_BACK    3

// menu selections (LEVEL SELECTION MP)
#define GAME_MENU_SELECTION_LEVEL_SELECTION_MP_LEVEL      0
#define GAME_MENU_SELECTION_LEVEL_SELECTION_MP_START      1
#define GAME_MENU_SELECTION_LEVEL_SELECTION_MP_DISCONNECT 2

// the virtual keyboard rest distance
#define VIRTUAL_KEYBOARD_REST_Y 50.0f

// the virtual keyboard states
#define VIRTUAL_KEYBOARD_STATE_HIDE 0
#define VIRTUAL_KEYBOARD_STATE_SHOW 1

// player name
extern char playerName[16];
extern int  playerNameN;

// list of connected players
extern char playerNameList[4][16];
extern int  playerNameListN[4];

// server name
extern char serverName[16];
extern int  serverNameN;

// the game camera
extern float gameCameraX;
extern float gameCameraY;
extern float gameCameraZ;

// the camera angle
extern float gameCameraAngle;

// the size of tile map
extern int tileMapDX;
extern int tileMapDY;

// the tile size
extern float tileDX;
extern float tileDY;

// the tile collision table
extern int tileCollisions[];

// the tile map
extern int tileMap[32][32];

// the bases
extern int baseCoordinates[];

// are the bases enabled?
extern int baseEnabled[4];

// the run time
extern float runTime;

// the player colors
extern int gamePlayerColors[];

void gameInit(void);
void gameIteration(float deltaTime);
void gameDraw(void);

void gameDrawString(float cX, float cY, float cZ, float scaleX, float scaleY, char *string, int centered);

#endif
