
/*
 *
 * file.c - File I/O
 *
 */

#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <pspgu.h>
#include <pspgum.h>
#include <psppower.h>

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <time.h>

#include "common.h"
#include "file.h"

// -----------------------------------------------------------------------
// load a file
// -----------------------------------------------------------------------

int fileLoad(char *name, unsigned char *data) {

	/*
	SceUID f;
	int i;

	f = sceIoOpen(name, PSP_O_RDONLY, 0777);
	if (f <= 0)
		return -1;

	i = sceIoLseek32(f, 0, PSP_SEEK_END);
	sceIoLseek32(f, 0, PSP_SEEK_SET);
	sceIoRead(f, data, i);
	sceIoClose(f);
	*/

	FILE *f;
	int i;

	f = fopen(name, "rb");
	if (f == NULL)
		return -1;

	fseek(f, 0, SEEK_END);
	i = ftell(f);
	fseek(f, 0, SEEK_SET);

	fread(data, 1, i, f);
	fclose(f);

	return i;
}

// -----------------------------------------------------------------------
// save a file
// -----------------------------------------------------------------------

int fileSave(char *name, unsigned char *data, int length) {

	/*
	SceUID f;

	if (!(f = sceIoOpen(name, PSP_O_WRONLY | PSP_O_CREAT, 0777)))
		return - 1;

	sceIoWrite(f, data, length);
	sceIoClose(f);
	*/

	FILE *f;

	f = fopen(name, "wb");
	if (f == NULL)
		return -1;

	fwrite(data, 1, length, f);
	fclose(f);

	return length;
}
